/*
 * Program to remove troublesome garbage files from the
 * current directory.
 *
 * Martin Houston.
 */
/********************************************************************
 * C Users Group (U.K) C Source Code Library File CUGLIB.020        *
 * Inquiries to: M. Houston, 36 Whetstone Clo. Farquhar Rd.         *
 * Edgbaston, Birmingham B15 2QN ENGLAND			    *
 ********************************************************************
 * File name: cleandir.c
 * Program name: cleandir
 * Source of file: Martin Houston
 * Purpose: Will go through a Xenix directory offering the user the
 * chance to delete any files that have 'garbage' characters in their
 * names that prevent removal by wild card matching. (In the present
 * version of Xenix the '*' wildcard only expands to the 7 bit Ascii
 * set).
 * Changes: <who what when & why major changes have been made>      
 ********************************************************************/


#include <stdio.h>
#include <fcntl.h>
#include <sys/param.h>

#define same(X,Y)	(!strcmp(X,Y))

#ifndef	DIRSIZ
#define	DIRSIZ	14
#endif
struct	direct
{
	ino_t	d_ino;
	char	d_name[DIRSIZ];
};

struct direct entry;

extern int errno;

char *show(s)
char *s;
{
    static char buf[80];
    char temp[80];

    strcpy(buf, "");
    while(*s)
    {
	if(*s < ' ')
	{
	    sprintf(temp, "(%x)", *s);
        }
	else
	{
	    sprintf(temp, "%c", *s);
        }

	s++;
	strcat(buf, temp);
    }

    return(buf);
}

badname(s)
char *s;
{
    while(*s)
    {
	if((*s <= ' ') || (*s > '~'))
	{
	    return 1;
        }
	s++;
    }

    return 0;
}

main(argc, argv)
int argc;
char *argv[];
{

    int dir;
    int response;
    int workdone = 0;
   
    fprintf(stdout, "Martins Directory Cleaning Service.\n");
    if((dir = open(".", O_RDONLY)) < 0)
    {
	fprintf(stderr,"Error: %s cannot open directory\n");
	exit(1);
    }

    while(read(dir, &entry, sizeof(struct direct)) > 0)
    {
	if((same(entry.d_name, ".")) || (same(entry.d_name, "..")))
	    continue;

        if((entry.d_ino) && (badname(entry.d_name)))
	{
	    fprintf(stdout,"Delete %s (y/n) ?", show(entry.d_name));
	    while(((response = getchar()) != 'n') && (response != 'y'))
		;
	    if(response == 'y')
	    {
	        fprintf(stdout,"Deleting %s \n", show(entry.d_name));
	        if(unlink(entry.d_name) < 0)
	        {
		    fprintf(stderr, "unlink of %s fails\n", show(entry.d_name));
                }
		workdone = 1;
            }
        }
    }

    if(!workdone)
        fprintf(stdout, "cannot find any files that are not removeable by rm\n");
}
